#include<iostream>
using namespace std;

int main(){
	int br=0,br2=0,par,zbirr=0,zbirq=0;
	int N, Q; 
	cin>>N;
	cin>>Q;
	int bd;
	long int q[Q];
	int niz[N];
	int niz1[N];
	
	for(int i=0;i<N;i++){
		cin>>niz[i];
		cin>>niz1[i];
		zbirr=zbirr+niz1[i];
	}
	for(int i=0;i<Q;i++){
		cin>>q[i];
		zbirq=zbirq+q[i];
	}
	bd= niz[N-1]+niz1[N-1]+q[Q-1];


	int nizd[bd]={0};
    int zbir[bd]={0};
	
	
	for(int i=0;i<N;i++){
		zbir[niz[i]]=zbir[niz[i]]+niz1[i];	
	}
	
	for(int i=0;i<bd;i++){
		nizd[i]=nizd[i]+zbir[i];
	}

	 for(int i=0;i<bd;i++){
			if(nizd[i]!=0){
				nizd[i+1]=nizd[i]-1+zbir[i+1];
				br++;
	    	}
		}
		
	
	
	cout<<endl;
	if(q[Q-1]<zbirr){
	for(int i=0;i<Q;i++){
		par=q[i];
		br2=0;
		for(int j=0;j<=par;j++){
			if(nizd[j]!=0)
			br2++;
		}
		cout<<br2<<" ";
		cout<<endl;
		

		}	
	}
	if(zbirq>zbirr)
	cout<<zbirq-zbirr;
	
		
     
   }